// Movement Main
function scr_movement_main(){
	// Get the player's input
	key_right = keyboard_check(right);
	key_left = -keyboard_check(left);
	key_jump = keyboard_check_pressed(jump);
	
	// Colliding object
	var object = obj_par_solid;

	// React to inputs and gravity
	move_dir = key_left + key_right; // Direction of movement
	hsp = move_dir * movespeed * speed_modif * (hearts * 0.5); // Horizontal (x) Speed * speed modifier
	
	// Jump If touching the ground
	terminal_velocity = obj_control.Players_terminalVelocity;
	if(vsp < terminal_velocity) vsp += grav; // !reaching terminal velocity increase velocity
	
	// Jumping
	if(place_meeting(x, y + 1, object)){ // Jump
		vsp = key_jump * -jumpspeed;
		airbound = true;
	} else if(key_jump && (st_double_jump || st_double_jump_pad) && airbound){ // Double Jump
		vsp = key_jump * -jumpspeed;
		airbound = false;
		st_double_jump_pad = false;
	}
		
	// Horizontal collision
	if(place_meeting(x + hsp,y, object)){
	    while(!place_meeting(x + sign(hsp), y, object)){
	        x += sign(hsp);
	    }
	    hsp = 0;// Resets Horizontal (x) Speed
	}
	x += hsp; // Moves Player's x
	
	// Vertical collision
	if(place_meeting(x, y + vsp, object)){
	    while(!place_meeting(x, y + sign(vsp), object)){
	        y += sign(vsp);
	    }
	    vsp = 0; // Resets Vertical (y) Speed
	}
	y += vsp; // Moves Player's y
}